require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_S390_BITOPS_H)) {
    eval 'sub _S390_BITOPS_H () {1;}' unless defined(&_S390_BITOPS_H);
    require 'linux/config.ph';
    if(defined(&__KERNEL__)) {
	eval 'sub ALIGN_CS () {0;}' unless defined(&ALIGN_CS);
    } else {
	eval 'sub ALIGN_CS () {1;}' unless defined(&ALIGN_CS);
	unless(defined(&CONFIG_SMP)) {
	    die("bitops won't work without CONFIG_SMP");
	}
    }
    unless(defined(&__s390x__)) {
	eval 'sub __BITOPS_ALIGN () {3;}' unless defined(&__BITOPS_ALIGN);
	eval 'sub __BITOPS_WORDSIZE () {32;}' unless defined(&__BITOPS_WORDSIZE);
	eval 'sub __BITOPS_OR () {"or";}' unless defined(&__BITOPS_OR);
	eval 'sub __BITOPS_AND () {"nr";}' unless defined(&__BITOPS_AND);
	eval 'sub __BITOPS_XOR () {"xr";}' unless defined(&__BITOPS_XOR);
	eval 'sub __BITOPS_LOOP {
	    local($__old, $__new, $__addr, $__val, $__op_string) = @_;
    	    eval q( &__asm__  &__volatile__(\\"   l   %0,0(%4)\\\\n\\" \\"0: lr  %1,%0\\\\n\\" $__op_string \\"  %1,%3\\\\n\\" \\"   cs  %0,%1,0(%4)\\\\n\\" \\"   jl  0b\\" : \\"=&d\\" , \\"=&d\\" , \\"=m\\" (* $__addr) : \\"d\\" , \\"a\\" , \\"m\\" (* $__addr) : \\"cc\\" ););
	}' unless defined(&__BITOPS_LOOP);
    } else {
	eval 'sub __BITOPS_ALIGN () {7;}' unless defined(&__BITOPS_ALIGN);
	eval 'sub __BITOPS_WORDSIZE () {64;}' unless defined(&__BITOPS_WORDSIZE);
	eval 'sub __BITOPS_OR () {"ogr";}' unless defined(&__BITOPS_OR);
	eval 'sub __BITOPS_AND () {"ngr";}' unless defined(&__BITOPS_AND);
	eval 'sub __BITOPS_XOR () {"xgr";}' unless defined(&__BITOPS_XOR);
	eval 'sub __BITOPS_LOOP {
	    local($__old, $__new, $__addr, $__val, $__op_string) = @_;
    	    eval q( &__asm__  &__volatile__(\\"   lg  %0,0(%4)\\\\n\\" \\"0: lgr %1,%0\\\\n\\" $__op_string \\"  %1,%3\\\\n\\" \\"   csg %0,%1,0(%4)\\\\n\\" \\"   jl  0b\\" : \\"=&d\\" , \\"=&d\\" , \\"=m\\" (* $__addr) : \\"d\\" , \\"a\\" , \\"m\\" (* $__addr) : \\"cc\\" ););
	}' unless defined(&__BITOPS_LOOP);
    }
    if(defined(&CONFIG_SMP)) {
	if((defined(&ALIGN_CS) ? &ALIGN_CS : 0) == 1) {
	}
	if((defined(&ALIGN_CS) ? &ALIGN_CS : 0) == 1) {
	}
	if((defined(&ALIGN_CS) ? &ALIGN_CS : 0) == 1) {
	}
	if((defined(&ALIGN_CS) ? &ALIGN_CS : 0) == 1) {
	}
	if((defined(&ALIGN_CS) ? &ALIGN_CS : 0) == 1) {
	}
	if((defined(&ALIGN_CS) ? &ALIGN_CS : 0) == 1) {
	}
    }
    eval 'sub set_bit_simple {
        local($nr,$addr) = @_;
	    eval q(( &__builtin_constant_p(($nr)) ?  &__constant_set_bit(($nr),($addr)) :  &__set_bit(($nr),($addr)) ));
    }' unless defined(&set_bit_simple);
    eval 'sub clear_bit_simple {
        local($nr,$addr) = @_;
	    eval q(( &__builtin_constant_p(($nr)) ?  &__constant_clear_bit(($nr),($addr)) :  &__clear_bit(($nr),($addr)) ));
    }' unless defined(&clear_bit_simple);
    eval 'sub change_bit_simple {
        local($nr,$addr) = @_;
	    eval q(( &__builtin_constant_p(($nr)) ?  &__constant_change_bit(($nr),($addr)) :  &__change_bit(($nr),($addr)) ));
    }' unless defined(&change_bit_simple);
    eval 'sub __test_and_set_bit {
        local($X,$Y) = @_;
	    eval q( &test_and_set_bit_simple($X,$Y));
    }' unless defined(&__test_and_set_bit);
    eval 'sub __test_and_clear_bit {
        local($X,$Y) = @_;
	    eval q( &test_and_clear_bit_simple($X,$Y));
    }' unless defined(&__test_and_clear_bit);
    eval 'sub __test_and_change_bit {
        local($X,$Y) = @_;
	    eval q( &test_and_change_bit_simple($X,$Y));
    }' unless defined(&__test_and_change_bit);
    if(defined(&CONFIG_SMP)) {
	eval 'sub set_bit () { &set_bit_cs;}' unless defined(&set_bit);
	eval 'sub clear_bit () { &clear_bit_cs;}' unless defined(&clear_bit);
	eval 'sub change_bit () { &change_bit_cs;}' unless defined(&change_bit);
	eval 'sub test_and_set_bit () { &test_and_set_bit_cs;}' unless defined(&test_and_set_bit);
	eval 'sub test_and_clear_bit () { &test_and_clear_bit_cs;}' unless defined(&test_and_clear_bit);
	eval 'sub test_and_change_bit () { &test_and_change_bit_cs;}' unless defined(&test_and_change_bit);
    } else {
	eval 'sub set_bit () { &set_bit_simple;}' unless defined(&set_bit);
	eval 'sub clear_bit () { &clear_bit_simple;}' unless defined(&clear_bit);
	eval 'sub change_bit () { &change_bit_simple;}' unless defined(&change_bit);
	eval 'sub test_and_set_bit () { &test_and_set_bit_simple;}' unless defined(&test_and_set_bit);
	eval 'sub test_and_clear_bit () { &test_and_clear_bit_simple;}' unless defined(&test_and_clear_bit);
	eval 'sub test_and_change_bit () { &test_and_change_bit_simple;}' unless defined(&test_and_change_bit);
    }
    eval 'sub test_bit {
        local($nr,$addr) = @_;
	    eval q(( &__builtin_constant_p(($nr)) ?  &__constant_test_bit(($nr),($addr)) :  &__test_bit(($nr),($addr)) ));
    }' unless defined(&test_bit);
    unless(defined(&__s390x__)) {
    } else {
    }
1;
